CREATE TABLE ARTICLE (
	ARTICLE_ID	NUMBER(10)	NOT NULL,
	PARENT_ID	NUMBER(10)	NOT NULL,
	GROUP_ID	NUMBER(10)	NOT NULL,
	ARTICLE_LEVEL	NUMBER(10)	NOT NULL,
	ORDER_NO	NUMBER(10) NOT NULL,
	CATEGORY	NUMBER(10)	NOT NULL,
	IS_COMMENT	NUMBER(1)	NOT NULL,
	IS_DELETE	NUMBER(1)	NOT NULL,
	HIT		NUMBER(10) NOT NULL,
	WRITE_DATE	TIMESTAMP	NOT NULL,
	TITLE		VARCHAR2(100)	NOT NULL,
	NAME		VARCHAR2(20)	NOT NULL,
	PASSWORD	VARCHAR2(20)	NOT NULL,
	EMAIL		VARCHAR2(80),
	DATAFILE	VARCHAR2(40),
	CHECK(ARTICLE_ID > 0),
	CHECK(PARENT_ID > 0),
	CHECK(GROUP_ID > 0),
	CHECK(ARTICLE_LEVEL > 0),
	CHECK(ORDER_NO > 0),
	PRIMARY KEY(ARTICLE_ID)
);

CREATE TABLE CONTENT (
	ARTICLE_ID	NUMBER(10)	NOT NULL,
	CONTENT		LONG	NOT NULL,
	CHECK(ARTICLE_ID > 0),
	PRIMARY KEY(ARTICLE_ID),
	FOREIGN KEY(ARTICLE_ID) REFERENCES ARTICLE(ARTICLE_ID) ON DELETE CASCADE
);

CREATE TABLE COMMENTS (
	COMMENT_ID	NUMBER(10) NOT NULL,
	ARTICLE_ID	NUMBER(10)	NOT NULL,
	IS_DELETE	NUMBER(1)	NOT NULL,
	COMMENTS	VARCHAR2(4000)	NOT NULL,
	WRITE_DATE	TIMESTAMP	NOT NULL,
	NAME		VARCHAR2(20)	NOT NULL,
	PASSWORD	VARCHAR2(20) NOT NULL,
	CHECK(COMMENT_ID > 0),
	CHECK(ARTICLE_ID > 0),
	PRIMARY KEY(COMMENT_ID),
	FOREIGN KEY(ARTICLE_ID) REFERENCES ARTICLE(ARTICLE_ID) ON DELETE CASCADE
);

CREATE TABLE ID_SEQUENCE (
	TABLE_NAME	VARCHAR2(60)	PRIMARY KEY,
	LAST_ID	NUMBER(10)	NOT NULL
);

CREATE INDEX ARTICLE_INDEX on ARTICLE(GROUP_ID DESC, ORDER_NO ASC);



