package koreajang.action;

import java.io.IOException;
import java.sql.SQLException;

import javax.servlet.ServletException;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import koreajang.KJAction;
import koreajang.dao.DeleteQuery;
import koreajang.etc.KJ;

public class DeleteAction extends KJAction {
	DeleteQuery query = new DeleteQuery();

	public DeleteAction(HttpServletRequest request, HttpServletResponse response)
			throws IOException {
		super(request, response);
	}

	@Override
	public String doAction() throws ServletException, IOException, SQLException {
		String forwardURI = KJ.BBS + "/main.jsp";
		int article_id  = Integer.parseInt(request.getParameter("article_id"));
		String passwd = request.getParameter("passwd");
		
		if( hasReplyArticle(article_id) || !validateArticlePass(passwd, article_id)) {
			forwardURI = KJ.BBS + "/view.jsp";
			forwardURI = addParam(forwardURI, "article_id", ""+article_id);
			System.out.println("  ۾ ȿ ʽϴ.");
		} else {
			if(KJ.doDelete) {
				query.deleteArticleCompletely(article_id);
			} else {
				query.deleteArticle(article_id);
			}
		}
		
		if( request.getParameter("category") != null )
			forwardURI = addParam(forwardURI, "category", request.getParameter("category"));
		if( request.getParameter("page") != null)
			forwardURI = addParam(forwardURI, "page", request.getParameter("page"));
		
		return forwardURI;
	}
	
	public boolean hasReplyArticle(int article_id) {
		int count = query.getCountChildren(article_id);
		if( count > 0 ) return true;
		else return false;
	}
	
	public boolean validateArticlePass(String passwd, int article_id) {
		String sql = "select password from " +KJ.ArticleTable + " where article_id = ? ";
		String compare = query.getString(sql, article_id);
		System.out.println("pass:" + passwd + " compare:" + compare);
		return passwd.equals(compare);
	}
}
