package koreajang.action;

import java.io.IOException;
import java.sql.SQLException;

import javax.servlet.ServletException;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import koreajang.KJAction;
import koreajang.KJQuery;
import koreajang.bean.ArticleBean;
import koreajang.dao.WriteQuery;
import koreajang.etc.KJ;

public class WriteAction extends KJAction {
	WriteQuery query = new WriteQuery();

	public WriteAction(HttpServletRequest request, HttpServletResponse response) throws IOException {
		super(request, response);
	}

	@Override
	public String doAction() throws ServletException, IOException, SQLException {
		String forwardURI = KJ.BBS +"/main.jsp";
		ArticleBean aBean = new ArticleBean();
		
		setArticleBean(request, aBean);
		query.writeArticle(aBean);
		
		if( request.getParameter("category") != null )
			forwardURI = addParam(forwardURI, "category", request.getParameter("category"));
		if( request.getParameter("page") != null)
			forwardURI = addParam(forwardURI, "page", request.getParameter("page"));
		
		return forwardURI;
	}
	
	private void setArticleBean(HttpServletRequest request, ArticleBean aBean) throws SQLException{
		aBean.setARTICLE_ID(query.nextID(KJQuery.nextID, KJ.ArticleTable));
		aBean.setHIT(0);
		aBean.setIS_COMMENT(0);
		aBean.setIS_DELETE(0);
		aBean.setWRITE_DATE(null);
		aBean.setDATAFILE("null");			
		
		if( request.getParameter("email") == null ){
			aBean.setEMAIL("NAN");
		} else { 
			aBean.setEMAIL(reqStr("email"));
		}
		aBean.setCATEGORY(reqInt("article_category"));
		aBean.setNAME(reqStr("name"));
		aBean.setPASSWORD(reqStr("passwd"));
		aBean.setTITLE(reqStr("title"));
		aBean.setContent(reqStr("content"));

		if( request.getParameter("parent") == null || reqInt("parent") <= 0) {
			aBean.setPARENT_ID(KJ.Start);
			aBean.setGROUP_ID(query.nextGroupID());
			aBean.setORDER_NO(KJ.Start);
			aBean.setARTICLE_LEVEL(KJ.Start);
		} else {
			aBean.setPARENT_ID(reqInt("parent"));
			aBean.setGROUP_ID( query.getGroupID(aBean.getPARENT_ID()) );
			aBean.setORDER_NO( query.nextOrderNo(aBean.getGROUP_ID(),aBean.getPARENT_ID()) );
			aBean.setARTICLE_LEVEL( query.nextLevel(aBean.getPARENT_ID()) );
		}
	}
	
}
