package koreajang.control;
import java.io.IOException;
import java.sql.SQLException;

import javax.servlet.ServletException;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import koreajang.KJAction;
import koreajang.KJControl;
import koreajang.action.*;


public class Control extends KJControl {
	private static final long serialVersionUID = 1L;

	@Override
	protected String doControl(HttpServletRequest request, HttpServletResponse response)
	throws ServletException, IOException, SQLException {
		KJAction action = null;
		String forward = DEFAULT_URI;
		String actionCode = request.getParameter("action");
		
		if(actionCode.equals("main")) {
			action = new MainAction(request, response);
		}
		else if(actionCode.equals("write")) {
			action = new WriteAction(request, response);
		}
		else if(actionCode.equals("reply")) {
			action = new ReplyAction(request, response);
		}
		else if(actionCode.equals("view")) {
			action = new ViewAction(request, response);
		}
		else if(actionCode.equals("tomodify")) {
			action = new TomodifyAction(request, response);
		}
		else if(actionCode.equals("delete")) {
			action = new DeleteAction(request, response);
		}
		else if(actionCode.equals("deletereply")) {
			action = new DelReplyAction(request, response);
		}
		else if(actionCode.equals("modify")) {
			action = new ModifyAction(request, response);;
		}
		
		if(action != null)
			forward = action.doAction();
		
		System.out.println("forward:"+forward);
		return forward;
	}
}
