package koreajang.dao;

import java.sql.SQLException;

import koreajang.KJQuery;
import koreajang.etc.KJ;

public class DelReplyQuery extends KJQuery {

	public static final String deleteComment =
		"UPDATE " + KJ.CommentTable + " SET IS_DELETE = 1 WHERE COMMENT_ID = ?";
	public static final String deleteCommentCompletely =
		"DELETE FROM " + KJ.CommentTable + " WHERE COMMENT_ID = ?";
	public static final String deleteCommentCompletelyAtSeq =
		"UPDATE ID_SEQUENCE SET LAST_ID = LAST_ID-1 WHERE TABLE_NAME = ?";

	public int deleteComment(int comment_id) {
		String query = new String(DelReplyQuery.deleteComment);
		return updateDB(query, comment_id);
	}
	
	public void deleteCommentCompletely(int comment_id) throws SQLException {
		String query = new String(DelReplyQuery.deleteCommentCompletely);
		String querySeq = new String(DelReplyQuery.deleteCommentCompletelyAtSeq);
		
		try {
			connect();
			conn.setAutoCommit(false);
			updateDBunCon(query, comment_id);
			updateDBunCon(querySeq, KJ.CommentTable);
			conn.commit();
		} catch (SQLException e) {
			e.printStackTrace();
			conn.rollback();
		}
		finally {
			conn.setAutoCommit(true);
			disconnect();
		}
	}

}
