package koreajang.dao;

import java.sql.SQLException;

import koreajang.KJQuery;
import koreajang.etc.KJ;

public class DeleteQuery extends KJQuery {
	
	public static final String deleteArticle =
		"UPDATE " + KJ.ArticleTable + " SET IS_DELETE = 1 WHERE ARTICLE_ID = ?";
	public static final String deleteArticleCompletely =
		"DELETE FROM " + KJ.ArticleTable + " WHERE ARTICLE_ID = ?";
	public static final String deleteArticleCompletelyAtSeq =
		"UPDATE ID_SEQUENCE SET LAST_ID = LAST_ID-1 WHERE TABLE_NAME = ? ";
	public static final String getCountChildren =
		"SELECT COUNT(*) FROM " + KJ.ArticleTable +
		" WHERE PARENT_ID = ? AND IS_DELETE = 0 ";


	
	public int deleteArticle(int article_id) {
		String query = new String(DeleteQuery.deleteArticle);
		return updateDB(query, article_id);
	}
	
	public void deleteArticleCompletely(int article_id) throws SQLException {
		String query = new String(DeleteQuery.deleteArticleCompletely);
		String querySeq = new String(DeleteQuery.deleteArticleCompletelyAtSeq);
		
		try {
			connect();
			conn.setAutoCommit(false);
			updateDBunCon(query, article_id);
			updateDBunCon(querySeq, KJ.ArticleTable);
			conn.commit();
		} catch (SQLException e) {
			e.printStackTrace();
			conn.rollback();
		}
		finally {
			conn.setAutoCommit(true);
			disconnect();
		}
	}

	public int getCountChildren(int article_id) {
		String query = new String(DeleteQuery.getCountChildren);
		return getInt(query, article_id);
	}
	
	
}
