package koreajang.dao;


import koreajang.KJQuery;
import koreajang.bean.ArticleBean;
import koreajang.etc.KJ;
import koreajang.etc.KJList;
import koreajang.etc.KJMap;

public class MainQuery extends KJQuery {
	public static final String getArticleListCount=
		"SELECT COUNT(*) FROM " + KJ.ArticleTable + " WHERE IS_DELETE = 0";
	public static final String getArticleList =
		"SELECT ARTICLE_ID, PARENT_ID, GROUP_ID, ARTICLE_LEVEL," +
		"		ORDER_NO, CATEGORY, IS_COMMENT, IS_DELETE, HIT," +
		"		WRITE_DATE, TITLE, NAME, PASSWORD, EMAIL, DATAFILE," +
		"		RNUM " +
		"FROM (" +
		"	SELECT ARTICLE_ID, PARENT_ID, GROUP_ID, ARTICLE_LEVEL," +
		"			ORDER_NO, CATEGORY, IS_COMMENT, IS_DELETE, HIT," +
		"			WRITE_DATE, TITLE, NAME, PASSWORD, EMAIL, DATAFILE," +
		"			ROWNUM RNUM " +
		"	FROM " + KJ.ArticleTable +
		"	WHERE IS_DELETE = 0 " +
		"	ORDER BY GROUP_ID DESC, ORDER_NO ASC " +
		"   )" +
		"WHERE RNUM <= ? AND RNUM >= ?";	/* END , START */
	
	
	public static final String getArticleListCountOp=
		"SELECT COUNT(*) FROM " + KJ.ArticleTable +
		" WHERE CATEGORY = ? AND IS_DELETE = 0";
	public static final String getArticleListOp =
		"SELECT ARTICLE_ID, PARENT_ID, GROUP_ID, ARTICLE_LEVEL," +
		"		ORDER_NO, CATEGORY, IS_COMMENT, IS_DELETE, HIT," +
		"		WRITE_DATE, TITLE, NAME, PASSWORD, EMAIL, DATAFILE," +
		"		RNUM " +
		"FROM (" +
		"	SELECT ARTICLE_ID, PARENT_ID, GROUP_ID, ARTICLE_LEVEL," +
		"			ORDER_NO, CATEGORY, IS_COMMENT, IS_DELETE, HIT," +
		"			WRITE_DATE, TITLE, NAME, PASSWORD, EMAIL, DATAFILE," +
		"			ROWNUM RNUM " +
		"	FROM " + KJ.ArticleTable +
		"	WHERE IS_DELETE = 0 AND CATEGORY = ? " +
		"	ORDER BY GROUP_ID DESC, ARTICLE_LEVEL ASC, ORDER_NO ASC " +
		"   )" +
		"WHERE RNUM <= ? AND RNUM >= ?";	/* END , START */
	
	public KJList getArticleList(int startNum, int endNum) {
		KJList list;
		KJMap params = new KJMap();
		ArticleBean aBean = new ArticleBean();
		params.put(1, endNum);
		params.put(2, startNum);
		
		if( (list = getList(MainQuery.getArticleList, params, aBean)) != null ) {
			return list;
		}
		else {
			return null;
		}
	}
	
	public int getArticleListCount() {
		String query = new String(MainQuery.getArticleListCount);
		int count = -1;
		connect();
		try {
			pstmt = conn.prepareStatement(query);
			rs = pstmt.executeQuery();
			
			if(rs.next()){
				count = rs.getInt(1);
			} else {
				count = KJ.Start;
			}
			
		} catch(Exception e) {
			e.printStackTrace();
			return count;
		}
		finally {
			disconnect();
		}
		
		return count;
	}
	
	public KJList getArticleList(int startNum, int endNum, int category) {
		KJList list;
		KJMap params = new KJMap();
		ArticleBean aBean = new ArticleBean();
		params.put(1, category);
		params.put(2, endNum);
		params.put(3, startNum);
		
		if( (list = getList(MainQuery.getArticleListOp, params, aBean)) != null ) {
			return list;
		}
		else {
			return null;
		}
	}
	public int getArticleListCount(int category) {
		String query = new String(MainQuery.getArticleListCountOp);
		int count = -1;
		connect();
		try {
			pstmt = conn.prepareStatement(query);
			pstmt.setInt(1, category);
			rs = pstmt.executeQuery();
			
			if(rs.next()){
				count = rs.getInt(1);
			} else {
				count = KJ.Start;
			}
			
		} catch(Exception e) {
			e.printStackTrace();
			return count;
		}
		finally {
			disconnect();
		}
		
		return count;
	}	

}
