package koreajang.dao;

import java.io.StringReader;
import java.sql.SQLException;

import koreajang.KJQuery;
import koreajang.bean.ArticleBean;
import koreajang.etc.KJ;
import koreajang.etc.KJMap;

public class ModifyQuery extends KJQuery {

	public static final String modifyContent = 
		"UPDATE " + KJ.ContentTable + 
		" SET CONTENT = ? " +
		" WHERE ARTICLE_ID = ?";	
	
	public static final String modifyArticle = 
		"UPDATE " + KJ.ArticleTable +
		" SET HIT = HIT+1, TITLE = ? , EMAIL = ? " +
		" WHERE ARTICLE_ID = ?";
	
	public void modifyArticle(ArticleBean aBean) throws SQLException {
		String query = modifyArticle;
		KJMap params = new KJMap();
		params.put(1, aBean.getTITLE());
		params.put(2, aBean.getEMAIL());
		params.put(3, aBean.getARTICLE_ID());
		
		try {
			connect();
			conn.setAutoCommit(false);
			setDBunCon(query, params);
			modifyContent(aBean);
			conn.commit();
		} catch(Exception e) {
			e.printStackTrace();
			conn.rollback();
		}
		finally {
			conn.setAutoCommit(true);
			disconnect();
		}
	}
	
	private int modifyContent(ArticleBean aBean) throws SQLException {
		String query = new String(ModifyQuery.modifyContent);
		System.out.println("q : " + query);
		System.out.println("1 : " + aBean.getARTICLE_ID());
		System.out.println("2 : " + aBean.getContent());
		
		pstmt = conn.prepareStatement(query);
		pstmt.setCharacterStream( 1,
				new StringReader(aBean.getContent()),
				aBean.getContent().length() );
		pstmt.setString(2, new String(""+aBean.getARTICLE_ID()));
		return pstmt.executeUpdate();
	}

	

}
