package koreajang.dao;

import koreajang.KJQuery;
import koreajang.bean.ArticleBean;
import koreajang.bean.CommentBean;
import koreajang.etc.KJ;
import koreajang.etc.KJList;
import koreajang.etc.KJMap;

public class ViewQuery extends KJQuery {
	
	public static final String getArticle =
		"SELECT ARTICLE_ID, PARENT_ID, GROUP_ID, ARTICLE_LEVEL," +
		"		ORDER_NO, CATEGORY, IS_COMMENT, IS_DELETE, HIT," +
		"		WRITE_DATE, TITLE, NAME, PASSWORD, EMAIL, DATAFILE " +
		" FROM " + KJ.ArticleTable +
		" WHERE ARTICLE_ID = ?";
	public static final String getContent =
		"SELECT CONTENT " +
		" FROM " + KJ.ContentTable +
		" WHERE ARTICLE_ID = ?";
	public static final String hitArticle =
		"UPDATE " + KJ.ArticleTable + " SET HIT = HIT+1 WHERE ARTICLE_ID = ?";

	public static final String getComment =
		"SELECT COMMENT_ID, ARTICLE_ID, IS_DELETE, COMMENTS," +
		"		WRITE_DATE,	NAME, PASSWORD " +
		" FROM " + KJ.CommentTable +
		" WHERE ARTICLE_ID = ? AND IS_DELETE = 0 " +
		" ORDER BY COMMENT_ID DESC";
	
	
	
	public int hitArticle(int article_id) {
		return updateDB(ViewQuery.hitArticle, new Integer(article_id));
	}
	
	public ArticleBean getArticle(int article_id) {
		String query = new String(ViewQuery.getArticle);
		ArticleBean aBean = new ArticleBean();
		String content = new String();
		KJMap params = new KJMap();
		params.put(1, article_id);
			
		if( (aBean = (ArticleBean) getDB(query, params, aBean)) == null ) {
			return null;
		}
		
		content = getLongString(ViewQuery.getContent, params, "CONTENT");
		aBean.setContent(content);
		
		return aBean;
		
	}
	
	public KJList getCommentlist(int article_id) {
		KJList list = new KJList();
		KJMap params = new KJMap();
		params.put(1, article_id);
		if( (list = getList(ViewQuery.getComment, params, new CommentBean())) != null ) {
			return list;
		}
		else {
			return null;
		}
	}
	

}
