package koreajang;

import java.io.IOException;
import java.io.Reader;
import java.sql.*;

import javax.sql.*;
import javax.naming.*;

import koreajang.bean.CustomerBean;
import koreajang.bean.ProductBean;
import koreajang.etc.KJException;
import koreajang.etc.KJList;
import koreajang.etc.KJMap;
import koreajang.etc.KJsqlParamException;


public class KJQuery {
	private final boolean POOL = false;
	private final String DB = "datasource1";
	
	protected Connection conn = null;
	protected PreparedStatement pstmt = null;
	protected ResultSet rs = null;
	

			
	protected void connect() {
		try {
			if(POOL) {
			/* Ŀؼ Ǯ ̿ */
				Context initContext = new InitialContext();
				DataSource ds = (DataSource)initContext.lookup(DB);
				conn = ds.getConnection();
			} else {
			/* Ŀؼ Ǯ ̿ ʱ */
		        Class.forName("oracle.jdbc.driver.OracleDriver");
				conn = DriverManager.getConnection("JDBC:oracle:thin:@127.0.0.1:1521:XE", "jspbook", "manager");
			}
		}
		catch (Exception e) {
			e.printStackTrace();
		}
	}
	
	protected void disconnect() {
		if(pstmt != null) {
			try {
				pstmt.close();
			} catch (SQLException e) {
				e.printStackTrace();
			}
		}
		
		if(conn != null) {
			try {
				conn.close();
			} catch (SQLException e) {
				e.printStackTrace();
			}
		}
		
		if(rs != null) {
			try {
				rs.close();
			} catch (SQLException e) {
				e.printStackTrace();
			}
		}
		
	}
	
	
	public int updateDB(String query, Object param) {
	// update :  1
		int res = 0;
		connect();
		try {
			res = updateDBunCon(query, param);
		} catch(SQLException e) {
			disconnect();
		}
		return res;
	}
	public int updateDBunCon(String query, Object param) throws SQLException {
	//  :  1
		System.out.println("q : " + query);
		System.out.println("? : " + param);
		pstmt = conn.prepareStatement(query);
		if( param instanceof String) {
			pstmt.setString(1, (String)param);
		} else {
			pstmt.setInt(1, ((Integer)param).intValue());
		}
		return pstmt.executeUpdate();
	}
		
	public int setDB(String query, KJMap params) {
	//  :  n
		int res = 0;
		connect();
		try {
			res = setDBunCon(query, params);
		} catch(Exception e) {
			e.printStackTrace();
		} finally {
			disconnect();
		}
		return res;
	}
	public int setDBunCon(String query, KJMap params) throws Exception {
	//  :  n
		System.out.println("q : " + query.toString());
		pstmt = conn.prepareStatement(query);
		setParams(pstmt, params);
		return pstmt.executeUpdate();
	}

	
	public KJList getList(String query, KJMap params, KJBean bean) {
	//  :  n
		KJList beanList = new KJList();
		
		connect();
		try{
			System.out.println("q : " + query.toString());
			pstmt = conn.prepareStatement(query);
			setParams(pstmt, params);
			
			rs = pstmt.executeQuery();
			while(rs.next()) {
				bean = bean.getClass().newInstance();
				setKJBeanFromRS(rs, bean);
				beanList.add(bean);
			}
		}
		catch(Exception e) {
			e.printStackTrace();
			return null;
		}
		finally {
			disconnect();
		}
		
		return beanList;
	}

	public KJBean getDB(String query, KJMap params, KJBean bean) {
	//  :  1
		connect();
		try{
			System.out.println("q : " + query.toString());
			pstmt = conn.prepareStatement(query);
			setParams(pstmt, params);
			
			rs = pstmt.executeQuery();
			if(rs.next()) {
				setKJBeanFromRS(rs, bean);
			}
			
		}
		catch(Exception e) {
			e.printStackTrace();
			return null;
		}
		finally {
			disconnect();
		}
		
		return bean;
	}

	public String getLongString(String query, KJMap params, String attr) {
	// attr شϴ long string 
		String content = null;
		
		connect();
		Reader reader = null;
		try{
			System.out.println("q : " + query.toString());
			pstmt = conn.prepareStatement(query);
			setParams(pstmt, params);
			
			rs = pstmt.executeQuery();
			if(rs.next()) {
				reader = rs.getCharacterStream(attr);
				System.out.println("c : " + attr);
				char[] buff = new char[512];
				int len = -1;
				StringBuffer buffer = new StringBuffer(512);
				while( (len = reader.read(buff)) != -1 ) {
					buffer.append(buff, 0, len);
				}
				content = buffer.toString();
			}
			
		}
		catch(Exception e) {
			e.printStackTrace();
			return null;
		}
		finally {
			try {
				reader.close();
			} catch (IOException e) {
				e.printStackTrace();
			}
			disconnect();
		}
		
		return content;
	}
	
	
	public boolean setParams(PreparedStatement pstmt, KJMap params)
	throws KJsqlParamException, SQLException {
		// only String type and Integer type are acceptable.
		for ( int i = 1; params!=null && i <= params.size(); i++ ) {
			if( params.get(i) instanceof String ) {
				pstmt.setString(i, (String)params.get(i));
				System.out.println(i + "S : " + params.get(i));
			} else if( params.get(i) instanceof Integer) {
				pstmt.setInt(i, ((Integer)params.get(i)).intValue());
				System.out.println(i + "I : " + params.get(i));
			} else {
				throw new KJsqlParamException();
			}
		}
		return true;
	}
	
	public boolean setKJBeanFromRS(ResultSet rs, KJBean bean) throws KJException, SQLException {
		// only CustomerBean(without productlist), ProductBean
		if (bean instanceof CustomerBean) {
		System.out.println("CustomerBean setting");
			CustomerBean cBean = (CustomerBean)bean;
			//productList   ó .
			cBean.setAddress(rs.getString("address"));
			cBean.setAuth(rs.getInt("auth"));
			cBean.setCustomer_id(rs.getString("customer_id"));
			cBean.setCustomer_name(rs.getString("customer_name"));
			cBean.setJoindate(rs.getDate("joindate"));
			cBean.setPasswd(rs.getString("passwd"));
			cBean.setPhonnum(rs.getString("phonnum"));
			cBean.setRatings(rs.getInt("ratings"));

		} else if(bean instanceof ProductBean) {
		System.out.println("ProductBean setting");
			ProductBean pBean = (ProductBean) bean;
			pBean.setCatename(rs.getString("catename"));
			pBean.setEtc(rs.getString("etc"));
			pBean.setKind(rs.getInt("kind"));
			pBean.setPublisher(rs.getString("publisher"));
			pBean.setTitle(rs.getString("title"));
			pBean.setWriter(rs.getString("writer"));
			pBean.setPid(rs.getInt("pid"));
			
/*		
			// loan table
			pBean.setIs_return(rs.getInt("is_return"));
			pBean.setLoan_date(rs.getDate("loan_date"));
*/
		}
		else {
			System.out.println("unknowned bean");
			throw new KJsqlParamException();
		}
		return true;
	}
	

}