package koreajang.action;

import java.io.IOException;
import java.sql.SQLException;

import javax.servlet.ServletException;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import koreajang.KJAction;
import koreajang.dao.ProductListQuery;
import koreajang.etc.KJ;
import koreajang.etc.KJList;
import koreajang.etc.KJPage;
import koreajang.etc.KJpageException;

public class ProductSearchAction extends KJAction {

	public ProductSearchAction(HttpServletRequest request,
			HttpServletResponse response) throws IOException {
		super(request, response);
		// TODO Auto-generated constructor stub
	}

	@Override
	public String doAction() throws ServletException, IOException, SQLException {
		String forward = "kj/index.jsp";
		ProductListQuery query = new ProductListQuery();
		
		KJList searchList = new KJList();
		
		int startRow = 1;
		int endRow = 1;
		int pageNum = 1;
		int totalPageNum = 1;
		
		if(request.getParameter("page") == null){
			pageNum = 1;
		}else{
			pageNum = Integer.parseInt(request.getParameter("page"));
		}
		
		try {
			startRow = KJPage.getStartRow(pageNum, KJ.NlistPerPage);
			endRow = KJPage.getEndRow(pageNum, KJ.NlistPerPage);
		} catch (KJpageException e) {
			e.printStackTrace();
			startRow = 1;
			endRow = 1;
			pageNum = 1;
			totalPageNum = 1;
		}
		
		int kind = Integer.parseInt((String) request.getParameter("kind"));
		int target = Integer.parseInt((String)request.getParameter("target"));
		String keyword = "%"+(String)request.getParameter("keyword")+"%";
		
		//հ˻϶
		if(kind == 0){
			searchList = query.getAllList(target, keyword, startRow, endRow);
			totalPageNum = (int)(query.getAllListCount(target, keyword)/15)+1;
		}else{
			searchList = query.getKindList(kind, target, keyword, startRow, endRow);
			totalPageNum = (int)(query.getKindListCount(kind, target, keyword)/15)+1;
		}
		KJPage pageInfo = new KJPage(pageNum, startRow, endRow, KJ.NlistPerPage, totalPageNum);
		System.out.println("totlaPageNum = "+totalPageNum);
		
		request.setAttribute("searchList", searchList);
		request.setAttribute("pageInfo", pageInfo);
		request.setAttribute("kind", kind);
		request.setAttribute("target", target);
		request.setAttribute("keyword", keyword);
		
		request.setAttribute("includePage","result.jsp");
		return forward;
	}

}
