package koreajang.control;

import java.io.IOException;
import java.sql.SQLException;

import javax.servlet.ServletException;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import koreajang.KJAction;
import koreajang.KJControl;
import koreajang.action.*;

public class Control extends KJControl {

	@Override
	protected String doControl(HttpServletRequest request,
			HttpServletResponse response) throws ServletException, IOException,
			SQLException {
		KJAction action = null;
		String forward = DEFAULT_URI;
		
		request.setCharacterEncoding("euc-kr");
		
		String actionCode = request.getParameter("action");
		
		if(actionCode.equals("main")){
			action = new MainAction(request, response);
		}
		else if(actionCode.equals("login")){
			action = new LoginAction(request, response);
		}
		else if(actionCode.equals("logout")){
			action = new LogoutAction(request, response);
		}
		else if(actionCode.equals("search")){ 
			action = new ProductSearchAction(request, response);
		}
		else if(actionCode.equals("customersearch")){
			action = new CustomerSearchAction(request, response);
		}
		else if(actionCode.equals("modifyPDpage")){
			action = new ProductViewAction(request, response);
			request.setAttribute("includePage","registerItem.jsp");
		}
		else if(actionCode.equals("newPDpage")){
			action = null;
			forward = "kj/index.jsp";
			request.setAttribute("includePage","registerItem.jsp");
		}
		else if(actionCode.equals("newPD")){
			action = new ProductInsertAction(request, response);
		}
		else if(actionCode.equals("modifyPD")){
			action = new ProductEditAction(request, response);
		}
		else if(actionCode.equals("deletePD")){
			action = new ProductDeleteAction(request, response);
		}
		else if(actionCode.equals("delManyPD")){
			action = new deleteManyProduct(request, response);
		}
		else if(actionCode.equals("showPD")){
			action = new ProductViewAction(request, response);
			request.setAttribute("includePage","showItem.jsp");
		}
		else if(actionCode.equals("rent")){
			action = new RentAction(request, response);
		}
		else if(actionCode.equals("return")){
			action = new ReturnAction(request, response);
		}else if(actionCode.equals("memberManage")){
			action = null;
			forward = "kj/index.jsp";
			request.setAttribute("includePage","memberSearch.jsp");
		}

		
		if(action != null)
			forward = action.doAction();
		return forward;
	}



}
