package koreajang.dao;

import koreajang.KJBean;
import koreajang.KJQuery;
import koreajang.bean.*;
import koreajang.etc.*;

public class ProductListQuery extends KJQuery {
	//ο  ֱ 7 / 
	public static final String getLatest7List = 
//		"SELECT * " +
//		"FROM product " +
//		"WHERE kind=? " + // 1  2
//		"ORDER BY pid desc";
		"SELECT * FROM (" +
		"	SELECT * " +
		"	FROM product " +
		"	WHERE kind=? " + // 1  2
		"	ORDER BY pid desc " +
		") WHERE ROWNUM <= 7";
	
	//հ˻
	public static final String getAllListCount=
		"SELECT COUNT(*) FROM product " +
		"WHERE ### like ?";
	public static final String getAllList=
		"SELECT * " +
		"FROM (" +
		"	SELECT pid,kind,catename,title,writer,publisher,etc, " +
		"			ROWNUM RNUM " +
		"	FROM product " +
		"	WHERE ### like ? " +	// , , ǻ
		"	ORDER BY pid desc " +
		"	)" +
		"WHERE RNUM <= ? AND RNUM >= ?";
	
	// ˻
	public static final String getKindListCount=
		"SELECT COUNT(*) FROM product " +
		"WHERE ### like ? " +
		"AND kind=? ";
	public static final String getKindList=
		"SELECT * " +
		"FROM (" +
		"	SELECT pid,kind,catename,title,writer,publisher,etc, " +
		"			ROWNUM RNUM " +
		"	FROM product " +
		"	WHERE kind=? " +
		"	AND ### like ? " +
		"	ORDER BY pid desc " +
		"	)" +
		"WHERE RNUM <= ? AND RNUM >= ?";
	
	public KJList getLatest7List(int kind) {
		KJList list;
		KJMap params = new KJMap();
		ProductBean pBean = new ProductBean();
		
		params.put(1, kind);
		
		if( (list = getList(ProductListQuery.getLatest7List, params, pBean)) != null ) {
			return list;
		}
		else {
			return null;
		}
	}
	
	public int getAllListCount(int target, String keyword) {
		int count = -1;
		KJMap params = new KJMap();
		String query = getAllListCount;
		
		switch(target){
			case 1:
				query = query.replaceFirst("###", "title");
				break;
			case 2:
				query = query.replaceFirst("###", "writer");
				break;
			case 3:
				query = query.replaceFirst("###", "publisher");
				break;
		}
		params.put(1, keyword);
	/*
		if((bean = getDB(ProductListQuery.getAllListCount, params, bean)) != null){
			count = Integer.parseInt(bean.toString());
		}
	*/
		connect();
		try{
			System.out.println("q : " + query);
			pstmt = conn.prepareStatement(query);
			setParams(pstmt, params);
			
			rs = pstmt.executeQuery();
			if(rs.next()){
				count = rs.getInt(1);
			}
		}catch(Exception e) {
			e.printStackTrace();
			return -1;
		}
		finally {
			disconnect();
		}
		
		return count;
	}
	
	public KJList getAllList(int target, String keyword, int startNum, int endNum) {
		KJList list;
		KJMap params = new KJMap();
		ProductBean pBean = new ProductBean();
		String query = getAllList;
		
		switch(target){
			case 1:
				query = query.replaceFirst("###", "title");
				break;
			case 2:
				query = query.replaceFirst("###", "writer");
				break;
			case 3:
				query = query.replaceFirst("###", "publisher");
				break;
		}
		params.put(1, keyword);
		params.put(2, endNum);
		params.put(3, startNum);
		if( (list = getList(query, params, pBean)) != null ) {
			return list;
		}
		else {
			return null;
		}
	}
	
	public int getKindListCount(int kind, int target, String keyword) {
		int count = -1;
		KJMap params = new KJMap();
		String query = getKindListCount;
		
		switch(target){
			case 1:
				query = query.replaceFirst("###", "title");
				break;
			case 2:
				query = query.replaceFirst("###", "writer");
				break;
			case 3:
				query = query.replaceFirst("###", "publisher");
				break;
		}
		params.put(1, keyword);
		params.put(2, kind);
	/*
		if((bean = getDB(ProductListQuery.getKindListCount, params, bean)) != null){
			count = Integer.parseInt(bean.toString());
		}
	*/	
		connect();
		try{
			System.out.println("q : " + query);
			pstmt = conn.prepareStatement(query);
			setParams(pstmt, params);
			
			rs = pstmt.executeQuery();
			if(rs.next()){
				count = rs.getInt(0);
			}
		}catch(Exception e) {
			e.printStackTrace();
			return -1;
		}
		finally {
			disconnect();
		}
		return count;
	}
	
	public KJList getKindList(int kind, int target, String keyword, int startNum, int endNum) {
		KJList list;
		KJMap params = new KJMap();
		ProductBean pBean = new ProductBean();
		String query = getKindList;
		
		params.put(1, kind);
		switch(target){
			case 1:
				query = query.replaceFirst("###", "title");
				break;
			case 2:
				query = query.replaceFirst("###", "writer");
				break;
			case 3:
				query = query.replaceFirst("###", "publisher");
				break;
		}
		params.put(2, keyword);
		params.put(3, endNum);
		params.put(4, startNum);
		
		if( (list = getList(query, params, pBean)) != null ) {
			return list;
		}
		else {
			return null;
		}
	}
}
