package koreajang.dao;

import java.sql.SQLException;

import koreajang.KJQuery;
import koreajang.bean.*;
import koreajang.etc.*;

public class ProductQuery extends KJQuery {
	public static final String deleteProduct = "DELETE FROM product WHERE pid = ?";
	public static final String insertProduct = 
		"INSERT INTO product "+
		"(pid,kind,catename,title,writer,publisher,etc) "+
		" VALUES(product_no.nextval,?,?,?,?,?,?)";
	public static final String updateProduct =
		"UPDATE product "+
		"SET kind=?,catename=?,title=?,writer=?,publisher=?,etc=? "+
		"WHERE pid=?";
	public static final String getlastProduct =
		"SELECT pid "+
		"FROM product "+
		"ORDER BY pid DESC";
	public int deleteProduct(int pid){
		return updateDB(deleteProduct, pid);
	}
	public int insertProduct(ProductBean pBean){
		KJMap insertMap = new KJMap();
		
		insertMap.put(1, pBean.getKind());
		insertMap.put(2, pBean.getCatename());
		insertMap.put(3, pBean.getTitle());
		insertMap.put(4, pBean.getWriter());
		insertMap.put(5, pBean.getPublisher());
		insertMap.put(6, pBean.getEtc());
		
		return setDB(insertProduct, insertMap);
	}
	public int updateProduct(ProductBean pBean){
		KJMap updateMap = new KJMap();
		
		updateMap.put(1, pBean.getKind());
		updateMap.put(2, pBean.getCatename());
		updateMap.put(3, pBean.getTitle());
		updateMap.put(4, pBean.getWriter());
		updateMap.put(5, pBean.getPublisher());
		updateMap.put(6, pBean.getEtc());
		updateMap.put(7, pBean.getPid());
		
		return setDB(updateProduct, updateMap);
	}
	public int LastProductID() throws SQLException{
		connect();
		pstmt = conn.prepareStatement(getlastProduct);
		rs = pstmt.executeQuery();
		if(rs.next())
			return rs.getInt("pid");
		return -1;
	}
}
